#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;

namespace HeuristicLab.Clients.OKB {
  [View("SetComparisonFilter View")]
  [Content(typeof(SetComparisonFilter), true)]
  public partial class SetComparisonFilterView : FilterView {
    public new SetComparisonFilter Content {
      get { return (SetComparisonFilter)base.Content; }
      set { base.Content = value; }
    }

    public SetComparisonFilterView() {
      InitializeComponent();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      comparisonComboBox.SelectedIndex = -1;
      if (Content != null) {
        if (Content.Comparison == SetComparison.Equal)
          comparisonComboBox.SelectedItem = "=";
        else if (Content.Comparison == SetComparison.NotEqual)
          comparisonComboBox.SelectedItem = "<>";
        else if (Content.Comparison == SetComparison.Contains)
          comparisonComboBox.SelectedItem = "contains";
        else if (Content.Comparison == SetComparison.NotContains)
          comparisonComboBox.SelectedItem = "not contains";
      }
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      comparisonComboBox.Enabled = Content != null && !ReadOnly;
    }

    private void comparisonComboBox_SelectedIndexChanged(object sender, System.EventArgs e) {
      if (Content != null) {
        if (comparisonComboBox.SelectedItem == "=")
          Content.Comparison = SetComparison.Equal;
        else if (comparisonComboBox.SelectedItem == "<>")
          Content.Comparison = SetComparison.NotEqual;
        else if (comparisonComboBox.SelectedItem == "contains")
          Content.Comparison = SetComparison.Contains;
        else if (comparisonComboBox.SelectedItem == "not contains")
          Content.Comparison = SetComparison.NotContains;
      }
    }
  }
}
